//---------------------------------------------------------------------------

#ifndef VMS0400MFH
#define VMS0400MFH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <DB.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <ADODB.hpp>
#include <ImgList.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------

#include "CenterCommF.h"
#include "DataTypesF.h"
#include "WindowMsgF.h"
#include "CDSVmsCtlrF.h"
#include "VMSWCAM0F.h"
#include "VMS0410MF.h"
//---------------------------------------------------------------------------
#include "cxContainer.hpp"
#include "cxControls.hpp"
#include "cxEdit.hpp"
#include "cxGraphics.hpp"
#include "cxGroupBox.hpp"
#include "cxLabel.hpp"
#include "cxLookAndFeelPainters.hpp"
#include "cxLookAndFeels.hpp"
#include "cxPC.hpp"
#include "cxPCdxBarPopupMenu.hpp"
#include "cxSplitter.hpp"
#include "dxSkinBlack.hpp"
#include "dxSkinBlue.hpp"
#include "dxSkinCaramel.hpp"
#include "dxSkinCoffee.hpp"
#include "dxSkinDarkRoom.hpp"
#include "dxSkinDarkSide.hpp"
#include "dxSkinFoggy.hpp"
#include "dxSkinGlassOceans.hpp"
#include "dxSkiniMaginary.hpp"
#include "dxSkinLilian.hpp"
#include "dxSkinLiquidSky.hpp"
#include "dxSkinLondonLiquidSky.hpp"
#include "dxSkinMcSkin.hpp"
#include "dxSkinMoneyTwins.hpp"
#include "dxSkinOffice2007Black.hpp"
#include "dxSkinOffice2007Blue.hpp"
#include "dxSkinOffice2007Green.hpp"
#include "dxSkinOffice2007Pink.hpp"
#include "dxSkinOffice2007Silver.hpp"
#include "dxSkinOffice2010Black.hpp"
#include "dxSkinOffice2010Blue.hpp"
#include "dxSkinOffice2010Silver.hpp"
#include "dxSkinsCore.hpp"
#include "dxSkinscxPCPainter.hpp"
#include "dxSkinSeven.hpp"
#include "dxSkinSharp.hpp"
#include "dxSkinSilver.hpp"
#include "dxSkinStardust.hpp"
#include "cxClasses.hpp"
#include "cxCustomData.hpp"
#include "cxData.hpp"
#include "cxDataStorage.hpp"
#include "cxFilter.hpp"
#include "cxGrid.hpp"
#include "cxGridCustomTableView.hpp"
#include "cxGridCustomView.hpp"
#include "cxGridLevel.hpp"
#include "cxGridTableView.hpp"
#include "cxStyles.hpp"
#include "cxTextEdit.hpp"
#include "cxGridCardView.hpp"
#include "cxGridCustomLayoutView.hpp"
#include "cxCheckBox.hpp"
#include "cxDropDownEdit.hpp"
#include "cxImage.hpp"
#include "cxButtons.hpp"
#include "FRAME_VmsStateF.h"
#include "FRAME_VmsMsgListF.h"

class TVMS0400M : public TForm
{
__published:	// IDE-managed Components
    TTimer *TmrShow;
    TPanel *PnlInfoRight;
    TcxSplitter *SplitterLeft;
    TPanel *PnlCenter;
    TPanel *PnlMapBack;
    TcxPageControl *PgFormTab;
    TcxTabSheet *TsList01;
    TPanel *PnlBottomLeft;
    TcxPageControl *PgVmsState;
    TcxTabSheet *TabVmsState;
    TPanel *PnlBottomRight;
    TcxPageControl *PgVmsIfscTraf;
    TcxTabSheet *TabVmsIfscTraf;
    TPanel *Panel1;
    TcxButton *BtnMonitoringMngr;
    TFRAMEVmsState *FRAMEVmsState1;
    TFRAMEVmsMsgList *FRAMEVmsMsgList1;
    TPopupMenu *PopupMenu1;
    TMenuItem *MnuViewMsg;
    TMenuItem *MnuEditScreen;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall TmrShowTimer(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall BtnMonitoringMngrClick(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall PgFormTabPageChanging(TObject *Sender, TcxTabSheet *NewPage,
          bool &AllowChange);
    void __fastcall MnuEditScreenClick(TObject *Sender);
    void __fastcall MnuViewMsgClick(TObject *Sender);
    void __fastcall SplitterLeftAfterClose(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
private:	// User declarations
    void __fastcall CommClose();

public:
    TVmsCtlr   *FSelVmsObj;
    TVMSWCAM0  *FSelForm;
	TList      *FListForm;

    int         FMonitoringType;
    bool        FReady;

public:		// User declarations
    __fastcall TVMS0400M(TComponent* Owner);

    void __fastcall LoadLocalSkin();

    void __fastcall InitMonitoringForm();

    void __fastcall CreateViewList();

    void __fastcall ActivateForm(bool AActivate);

    void __fastcall OnVmsSelectMessage(TMessage &Msg);
    void __fastcall OnMainFormMessage(TMessage &Msg);
    void __fastcall OnVmsStateRefreshMessage(TMessage &Msg);
    void __fastcall OnVmsFormRefreshMessage(TMessage &Msg);

    bool         IsFormResizing;
    int          FOldWidth, FOldHeight;
    TcxTabSheet *FCurrPage;
    void __fastcall WMEnterSizeMove(TMessage &Msg);
    void __fastcall WMExitSizeMove(TMessage &Msg);
    void __fastcall RecalFormSize();

	BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_ENTERSIZEMOVE, TMessage, WMEnterSizeMove)
        MESSAGE_HANDLER(WM_EXITSIZEMOVE, TMessage, WMExitSizeMove)

        MESSAGE_HANDLER(WM_VMS_SELECT, TMessage, OnVmsSelectMessage)
        MESSAGE_HANDLER(WM_MAINFORM, TMessage, OnMainFormMessage)
        MESSAGE_HANDLER(WM_VMS_STATE_REFRESH, TMessage, OnVmsStateRefreshMessage)
        MESSAGE_HANDLER(WM_VMS_FORM_REFRESH, TMessage, OnVmsFormRefreshMessage)
    END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TVMS0400M *VMS0400M;
//---------------------------------------------------------------------------

#endif

